﻿using System;
using System.Collections.Generic;
using System.Linq;
using Was.OrcSearch.Models.Interfaces;

namespace Was.OrcSearch.Models
{
    public class DictionaryMetadataCollection : MetadataCollectionBase
    {
        private readonly List<IMetadata> _metadata;

        public DictionaryMetadataCollection()
        {
            _metadata = new List<IMetadata>();
        }

        public DictionaryMetadataCollection(Dictionary<string, Type> dictionarySchema)
            : this()
        {
            _metadata = dictionarySchema.Select(kvp => new DictionaryMetadata(kvp.Key, kvp.Value)).Cast<IMetadata>()
                .ToList();
        }

        public override IEnumerable<IMetadata> All => _metadata;
    }
}